#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <string.h>
#include <unistd.h>

const int NB_THREADS = 2;
int parts_de_gateau = 4;

void *prendre_part(void * num)
{
	int numero = *((int *)num);

	while (parts_de_gateau > 0) {
		printf("Thread %d : il y a %d parts de gateau.\n", numero, parts_de_gateau);
		printf("Thread %d : mange une part de gateau.\n", numero);
		--parts_de_gateau;
		printf("Thread %d : il reste %d parts de gateau.\n", numero, parts_de_gateau);
		usleep(1);
	}

	pthread_exit(NULL);
}

int main(int argc, const char *argv[])
{
	pthread_t thread[NB_THREADS];
	int numero_thread[NB_THREADS];
	int i, ret;

	for (i = 0; i < NB_THREADS; ++i) {
		numero_thread[i] = i;
		ret = pthread_create (&thread[i], NULL, prendre_part, &numero_thread[i]);
		if (ret != 0) {
			perror("Erreur lors de la création du thread");
			exit(EXIT_FAILURE);
		}
	}

	for (i = 0; i < NB_THREADS; ++i) {
		pthread_join(thread [i], NULL);
	}

	printf("Main : il reste %d parts de gateau.\n", parts_de_gateau);

	return EXIT_SUCCESS;
}
